using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using System.Runtime.CompilerServices;
using Exferia_Mythos._0_Modelos;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Mythos.General;
using Exferia_Aplicacion.Modelos_Generales;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Mythos._3_Vistas.Listados
{
    public class ABS_Listado_MAE_Contactos_OrganismosCertificadores : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_MAE_Contactos_OrganismosCertificadores()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_Contactos_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_Contactos_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //codigo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_Contactos_Modelo.codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_Contactos_Modelo.codigo), "Código", Enumerados.G_ENUM_TIPOSDATOS.LONG_TEXT, false, 90, true, true, true, false, "", null));

            //descripcion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_Contactos_Modelo.descripcion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_Contactos_Modelo.descripcion), "Descripción", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 250, true, true, true, false, "", null));

            //CategoriaProfesional
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_CATEGORIAPROFESIONAL = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_Contactos_Modelo.idCategoriaProfesional), nameof(MAE_CategoriasProfesionales), nameof(MAE_CategoriasProfesionales.id), nameof(MAE_CategoriasProfesionales.codigo), nameof(MAE_CategoriasProfesionales.descripcion), nameof(MAE_CategoriasProfesionales.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_Contactos_Modelo.CategoriaProfesional), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_Contactos_Modelo.CategoriaProfesional), "Categoría Profesional", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, true, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_CATEGORIAPROFESIONAL));

            //Departamento
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_DEPARTAMENTO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_Contactos_Modelo.idDepartamentoExterno), nameof(MAE_DepartamentosExternos), nameof(MAE_DepartamentosExternos.id), nameof(MAE_DepartamentosExternos.codigo), nameof(MAE_DepartamentosExternos.descripcion), nameof(MAE_DepartamentosExternos.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_Contactos_Modelo.DepartamentoExterno), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_Contactos_Modelo.DepartamentoExterno), "Departamento externo", G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, true, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_DEPARTAMENTO));

            //ProcesosEmail
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_PROCESOEMAIL = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_Contactos_Modelo.idContactoProcesoEmail), nameof(MAE_ContactosProcesosEmail), nameof(MAE_ContactosProcesosEmail.id), nameof(MAE_ContactosProcesosEmail.codigo), nameof(MAE_ContactosProcesosEmail.descripcion), nameof(MAE_ContactosProcesosEmail.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_Contactos_Modelo.ProcesoEmail), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_Contactos_Modelo.ProcesoEmail), "Proceso Email", G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, true, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_PROCESOEMAIL));


            //Web
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_Contactos_Modelo.web), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_Contactos_Modelo.web), "Web", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 250, true, false, false, false, "", null));

            //Observaciones
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_Contactos_Modelo.observaciones), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_Contactos_Modelo.observaciones), "Observaciones", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 250, true, false, false, false, "", null));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_MAE_CONTACTO_ORGANISMOSCERTIFICADORES);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_MAE_CONTACTO_ORGANISMOSCERTIFICADORES;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_Contactos_Modelo.codigo);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
